#include<stdio.h>
#include<stdlib.h>
#include<fcntl.h>
#include<string.h>
#include<unistd.h>
#include<signal.h>
#include<pthread.h>
#include<arpa/inet.h>
#include<sys/types.h>
#include<sys/time.h>
#include<sys/stat.h>
#include<sys/wait.h>
#include<sys/socket.h>
#include<netinet/in.h>

#include<mysql/mysql.h>

#define BUFSIZE 1024 
#define PBUFSIZE 30

#include "global_val.h"
#include "def_struct.h"
#include "packet_func.h"
#include "db_access_func.h"
#include "action_thread.h"


/*--------------------------- Լ  ----------------------------*/
void error_handling(char *message);
void z_handler(int sig);
void *thread_function(void *arg);
void *clntck_thread_function(void *arg);//thread in forked process 

/*------------------------- db_access_func.h --------------------------*/
int getdata(char* query ,char* Rx_msg, int command,int flag);  //DB  ڷ  Select ..
int storedata(char* query, int command, int flag); //DB ϴ κ insert

/*------------------------- packet_func.h -----------------------------*/
void hdr_def(char *, int, int);
void Rec_hdr_def(char *, int, int, int);
int file_transmit(int clnt_sock, struct patch_file_inform * s_pid_file);


///////////////////////////////////// S T A R T ////////////////////////////
int main(int argc, char ** argv)
{
	int serv_sock;
	struct sockaddr_in serv_addr;
	struct sockaddr_in clnt_addr;

	//Threadκ 
	int pstate,pstate2;
	pthread_t t_id, t_id2;
	void *t_return;

	//Threadκ/
	struct sigaction act, act_alive;
	int addr_size, str_len, state;
	pid_t pid;
	time_t pre_time, next_time;
	char message[BUFSIZE];


////    
	char Rx_msg[BUFSIZE+1]; //Ǵ° 
	struct hdr *r_hdr;    
	r_hdr = (struct hdr*)Rx_msg; //ġ 
	
////  Recovery   
	char Rec_msg[BUFSIZE+1];
	struct Recv_hdr *Rcv_hdr;
	Rcv_hdr = (struct Recv_hdr*)Rec_msg; 

////     ʿ κ
	struct ident *r_ident;

//// 0804Client alive Check ü 
    struct alive *chck_alive;

////	 ġ ü 
	int pser_num=0 , num=0; //  ִ ׸  
	struct all_pinfo *sa_pinfo;
	
////    ġ  ´  Patch ü   
	int Patched_num=0;
	struct patch_info_data *s_info_data;
	//r_info_data = (struct patch_info_data*)(Rx_msg+sizeof(struct hdr));// ˻ ġ ȭƯ 

///     ŬƮ ʿ ġ (P_id)
	int need_count=0;
	int patch_list[PBUFSIZE]={0};
	struct need_patch_count *r_pid_data;
	struct need_patch_count *k_pid_data;

///      Ŭ̾Ʈ     ũ⸦  (Clientʿ ũ⸦  ٸ)
	struct tosend_file_info *s_file_size;
	struct stat statbuf; // size ˱  ͵
	
//////  ŬƮ  ׸  ϳ   ü 
	int Cnum=0;		
	struct patch_file_inform *s_pid_file;	

/////   backup   ֱ  ü
	struct backup_file_inform *r_backup_data;

//// 0723 Thread_action߻    dataü (߿Ѱ Header)
	struct Thread_Action_inform *thread_alive;

//// 0723 Recovery data ü 
	struct Recovery_file_inform *recovery_data; //  ʿ ü  
	
////
	int need_file=0;

//////
	if(argc != 2)
	{
		printf("Usage: %s <port> \n", argv[0]);
		exit(1);
	}

//// ó 
	act.sa_handler=z_handler; //Ǿ Լ 
	sigemptyset(&act.sa_mask);
	act.sa_flags=0;

	state=sigaction(SIGCHLD, &act, 0); //ñ׳ ڵ鷯  

	if(state != 0)
	{
		puts("Sigaction() error");
		exit(1);
	}

	serv_sock = socket(PF_INET, SOCK_STREAM, 0);
	memset(&serv_addr, 0, sizeof(serv_addr));
	serv_addr.sin_family = AF_INET;
	serv_addr.sin_addr.s_addr=htonl(INADDR_ANY);
	serv_addr.sin_port=htons(atoi(argv[1]));

	if(bind(serv_sock, (struct sockaddr*) &serv_addr, sizeof(serv_addr)) == -1)
	   error_handling("bind() error");

	if(listen(serv_sock, 5) == -1)
	   error_handling("listen() error");
	
	while(1)
	{
		addr_size = sizeof(clnt_addr);
		clnt_sock = accept(serv_sock, (struct sockaddr*)&clnt_addr, &addr_size);
		if( clnt_sock == -1)
			continue;
/////////// pipe ó
	   Checkclnt++;

/// α 
////     ʿ κ
				char *sql;
                sql = (char *)malloc(BUFSIZE*sizeof(char));
				memset(Rx_msg,0, BUFSIZE);

				str_len=read(clnt_sock, Rx_msg, BUFSIZE);

		    /////////
			if( r_hdr->command == 1)  //
       		{
	
                                r_ident = (struct ident*)(Rx_msg+sizeof(struct hdr)); //ġ

                                printf("0. ޾ƿ str_len: %d \n", str_len);
                                printf("0. ޾ƿ command : %d size(%d)\n", r_hdr->command,sizeof(r_hdr->command));
                                printf("0. ޾ƿ flag : %d size(%d)\n", r_hdr->flag, sizeof(r_hdr->flag));
                                printf("0. ޾ƿ id: %s: size(%d)\n", r_ident->id, sizeof(r_ident->id));
                                printf("0. ޾ƿ passwd: %s: size(%d)\n", r_ident->password, sizeof(r_ident->password));
					
                                // DB   ...
                                        memset(sql , 0 , sizeof(sql));
                                        char *query="SELECT id, passwd,uid FROM member where passwd=PASSWORD('%s') AND id='%s'"; 

                                        sprintf(sql, query, r_ident->password, r_ident->id);//,"name","id","passwd");

                                        printf(" \n  %s \n",sql);

                                //  (DB)Ϳ.
                                        getdata(sql,Rx_msg,1,0); //   return Ѵ.
							// Authentication
                                hdr_def(Rx_msg, 1, 1);                         //Authentication
                                //Ǿ 󰡴 κ
                                write(clnt_sock, Rx_msg ,BUFSIZE);
                                //End DB
	 		}
			else
			{
				printf(" \n  ̷ ʾҽϴ.ٽ Ͻʽÿ \n");
				exit(1);
			}
				

//////////////
	   printf(" \n\n\n   (%d°clnt).. \n\n",Checkclnt);
	   printf("  File Descript(clnt,server)=[%d,%d] \n\n ",clnt_sock,serv_sock); 

	  usleep(5000);
     
	   
/////////// pipe  struct list pipelist[100];

	   //Ŭ̾Ʈ    
	   if ( (pid = fork() ) == -1) // fork   
	   { 
		close(clnt_sock);
		
		continue;	
	   }
	   else if( pid> 0)  // θ μ  
	   {
		puts(" ");
		close(clnt_sock);  //θμ client_socket ݾش.	
		
			puts("DB_Thread ");
			printf(" \n\n [%d]° Ŭ̾Ʈ  \n\n",Checkclnt);
			printf(" \n  p[1]=%d pipe \n",p[1]);

			printf("\n\n====>>> ưϴ.(%d°Client)<<<====\n",Checkclnt);//Thread_check);
			pstate = pthread_create(&t_id, NULL, thread_function, NULL);//&Checkclnt);


            if(pstate !=0)
            {
                 puts("thread_function  ");
                 exit(1);
            }

		continue;
	   }
	   else  //ڽ μ  
	   {

		printf("\n\n##########  After Fork() .. File_descriptor=[c:%d,s:%d] #########\n\n",clnt_sock,serv_sock);
		close(serv_sock);

		//multiplexingκ 
		
		fd_set Reads, ReadMask;
		int fd_max;
		
		int clnt_num=0;
		int Sockfd=0;
		int Check_Sock[30]={0};

		int temp;
		int retval;
		
		FD_ZERO(&Reads);

		//ڽ μ ó  :     
		pstate2 = pthread_create(&t_id2, NULL, clntck_thread_function, NULL);

		if(pstate2 !=0) { puts("clntck_thread_function  ");  exit(1); }

		while(1)
		{
			int i,fd,rew;
		    struct timeval timeout;
	
			//Select Լ ˻ Ǵ  Ѵ. 
			Check_Sock[0]=clnt_sock;

			Check_Sock[1]=pipelist[clnt_uid].pipe_out; //DB ִ  ȣ < 𸥴.>


			FD_ZERO(&ReadMask);
			FD_SET(Check_Sock[0], &ReadMask);
			FD_SET(Check_Sock[1], &ReadMask); 

			timeout.tv_sec = 10;
			timeout.tv_usec = 0;

			fd_max=Check_Sock[1];
			if(Check_Sock[1] < Check_Sock[0])
			fd_max=Check_Sock[0];
				
			retval=0; 
			printf("?");

			usleep(500);
		   
			
		retval = select(fd_max+1 , &ReadMask, 0,0, &timeout);  //256 

			printf(" \n Selectٷ  -- retval=%d -- \n",retval);

		if(retval == -1)
			   error_handling(" Select() ߻");

		     	
		else if(retval)
		{
			//κ ȣ شϴ fd ߰ .
			if(FD_ISSET(pipelist[clnt_uid].pipe_out,&ReadMask)) // ȣ  
			{
				int relen;

				char Rm_msg[BUFSIZE+1]; //  
				struct Recv_hdr *rm_hdr;
				rm_hdr = (struct Recv_hdr*)Rm_msg;

				memset(Rm_msg, 0, sizeof(Rm_msg));

				relen=read(pipelist[clnt_uid].pipe_out, Rm_msg, sizeof(Rm_msg)); 

						printf("\n  <<<==%d, %d, %d==>>> \n",rm_hdr->command, rm_hdr->flag ,rm_hdr->Rec_flag);//relen);

				printf("\n Thread κ ȣ (%d):^^(%d)° Ŭ̾Ʈ  [%d] DB ٷο..[%s]\n",pipelist[Checkclnt].pipe_out,Checkclnt, getpid(),Rx_msg);

			    Check_Sock[1] = p[0]; 

				//pipe command
				if(rm_hdr->command == 1)
				{
					if(rm_hdr->flag == 3)//Patch Signal
					{
						printf("\n  ġ(%d,%d,%d) Ŭ̾Ʈ ..\n",rm_hdr->command, rm_hdr->flag, rm_hdr->Rec_flag);
						/////////////////
						//   dataü Ⱦ. //
						///////////
						//clnt 2.0 ϴ packet
					
						//޾ƿ Rm_msg ״  (3°ڸ ״ )
						write(clnt_sock, Rm_msg, BUFSIZE); 
						usleep(5000);
					}// 1_flag.3
					else if(rm_hdr->flag == 4) //Recovery Signal clnt 6.0  
					{

						printf(" \n   (%d, %d, %d)   .. \n",rm_hdr->command,rm_hdr->flag,rm_hdr->Rec_flag);
						
						//޾ƿ Rm_msg ״ (3°ڸ ״ ) 
						write(clnt_sock, Rm_msg, BUFSIZE);
						usleep(5000);	
					}// 1_flag.4
				}//1.command	
		 
			}// fd_set   ..

			// ȣ ó 
			else if(FD_ISSET(Check_Sock[0], &ReadMask))
			{
				memset(Rx_msg, 0, BUFSIZE);	
				str_len = read(clnt_sock, Rx_msg, BUFSIZE);
				sleep(1);
				printf(" Select  str_len = %d \n", str_len);

				//0819  Ȯ κ 
				// 10.1  ʾҴٴ ̹Ƿ Ŭ̾Ʈ ׾. (updateȵǾǷ)
				// select fd νϴµ readκп '0'̹Ƿ ִ Ȯϱ 
				// 10.0 ٽ . ٽ   ̴..
				if(str_len == 0)
				{
					 hdr_def(Rx_msg, 10, 0);
					 chck_alive = (struct alive*)(Rx_msg + sizeof(struct hdr));

                     strcpy(chck_alive->check,"=from server ֳ?=");
	                 rew=write(clnt_sock, Rx_msg, BUFSIZE);

					 if( rew < 0 )
					 {
						 printf("\n== Ŭ̾Ʈ ׾(return Value:[%d])..==\n",rew);
						 exit(clnt_uid);
					 }
				}

				//0819end

////////////// ȣ ȿ Ͼ  

			if(r_hdr->command == 2) //Ŭ̾Ʈκ ġû<غϷ> 
			{
		        	if(r_hdr->flag == 0)
				    {

			     ////	//׳ Ȯϱؼ ؿ .
					printf("2. ޾ƿ str_len: %d \n", str_len);
					printf("2. ޾ƿ command : %d size(%d)\n", r_hdr->command,sizeof(r_hdr->command));
					printf("2. ޾ƿ flag : %d size(%d)\n", r_hdr->flag, sizeof(r_hdr->flag));
					printf("2. ޾ƿ id: %s: size(%d)\n", r_ident->id, sizeof(r_ident->id));
					printf("2. ޾ƿ passwd: %s: size(%d)\n", r_ident->password, sizeof(r_ident->password));
			    /////

					//ش.  ġ ü(ġlist)
					hdr_def(Rx_msg, 2, 1); //   Ѵ.~~
					sa_pinfo = (struct all_pinfo*)(Rx_msg+sizeof(struct hdr));//̰ ڿ				

					// DB   ...
						memset(sql , 0 , sizeof(sql));
						char *query="SELECT count(%s) FROM test_info_data";
						sprintf(sql, query,"p_id");

						printf(" \n [2.1] %s \n",sql);

					   //  (DB)Ϳ.
					// DBAcess  ü patchfile  üũ 
						pser_num=getdata(sql,Rx_msg,2,1); // ġ  return ѱ.
					   //End DB	

					sa_pinfo->all_patch_list = pser_num; //(DB)  ִ ü Patch list
					Patched_num = sa_pinfo->all_patch_list; //patchlist 

					write(clnt_sock, Rx_msg, BUFSIZE);	
					//  ġ ü ٺ 

					
					//1. ġŭ 2. DB Access  
					for( num = 1 ; num <= Patched_num ; num++)  //NUM DB εȰ Ѵ.
					{ 

						hdr_def(Rx_msg, 2, 2); //  
						//ϳ Patch_ Է¹..
						//db_access(Rx_msg,num); // ϳ  

						memset(sql , 0 , sizeof(sql));
						char *query="SELECT %s,%s,%s,%s,%s, %s FROM test_info_data";
						sprintf(sql, query,"p_id","p_name","search_opt","filename","pattern","p_option");

						printf(" \n [2.2] =[%s] \n",sql);

					   //  (DB)Ϳ.
						getdata(sql,Rx_msg,2,2); //   return Ѵ.
					   //End DB
					   //
						write(clnt_sock, Rx_msg, BUFSIZE);	

					}//End of for						
					
					//ġ׸ ٺ ۾ǳ   .
						hdr_def(Rx_msg, 2,3);
					        sa_pinfo = (struct all_pinfo*)(Rx_msg+sizeof(struct hdr));//̰ ڿ				
						//5==> pser_num ٲ
					        sa_pinfo->all_patch_list = pser_num; //(DB)  ִ ü Patch list
					// DB   ...
						write(clnt_sock, Rx_msg, BUFSIZE);
				}//_2.flag.0
			}// command.2
		/////////////////////
			else if( r_hdr->command == 3)
			{
				if(r_hdr->flag == 0)
				{
					int i=1;
					need_file=0;
				
					// Ȳ ˸ 
						gcommand = r_hdr->command;
						gflag = r_hdr->flag;
				    ////////////////////////
					
					r_pid_data = (struct need_patch_count*)(Rx_msg+sizeof(struct hdr));
					k_pid_data = r_pid_data;

					printf(" \n [3.0] [%s] \n", sql);
					
					printf("\n == Need_to_patch_count == \n");

					printf("r_pid_data->count=%d\n",r_pid_data->count);
					 
					sleep(3);	

					for(need_count =0; need_count < r_pid_data->count; need_count++) 
					{
						printf("\n check = %d count : %d\n", r_pid_data->list[need_count], need_count );

						// ʿ list 
						if(r_pid_data->list[need_count] == 1)
						{
							  patch_list[need_file] = need_count;
							  need_file++;
						}
 					}// 0530

					printf("\n Ŭ̾Ʈ  ʿ ġ   \n\n");

					///û list  ġ & ġ شϴ   üũ(DB) 
					
					//////////
					/// Ŭ̾Ʈ ִ index ѹ ϳ ޾Ƽ 
					/// DBٰ ε  ǥø   DB ARRA  
					/// Check_db_patch( index );
					/////////
					
					//struct need_patch_count *r_pid;
					////Need_Count++;

					/*------- ReSetting --------*/
					timeout.tv_sec = 30;
					/*--------------------------*/
				}// flag.0
				else if(r_hdr->flag == 1) //3.1 ġ Ƿ .. Ϸ 010111 شϴ ϵ 
				{	

					printf("\n Ŭ̾Ʈ  ʿġ(ü) \n");
					//s_pid_file = (struct patch_file_inform*)(Rx_msg+sizeof(struct hdr));
					
		    ///////////////////   >>>>  ۺ <<<<    ///////////////////

		 	////   Needfile 4 ҴǸ 

					int file_i;
					int needfile;//=k_pid_data->count; // 0530
					printf("\n need_file=%d \n",need_file);

					for(file_i=0 ; file_i<need_file; file_i++)
	 				{
						printf(" patch_list[%d]=%d\n",file_i,patch_list[file_i]);

						//hdr 3,0  DB Ʈ ʿ ׸ üũѰ 
						//üũ index ϰ ִ.
						// 0101011  ׸ 2,4,6,7̷ شϴ  DB Ѵ.
    				  	//   Check_num[4]={2,4,6,7} 4 
						//׸ ϵ ϳ  Ѵ. 
						/// 1.ϱ  Size  Ŭ̾Ʈ  
						///////////
						hdr_def(Rx_msg, 4, 0);//  4.0 -
						s_pid_file = (struct patch_file_inform*)(Rx_msg+sizeof(struct hdr)); //ڿ ̰
						//DB  شϴ  DB Ѵ.
							memset(sql, 0, sizeof(sql)); //û 
							char *query="SELECT %s, %s FROM patch_info_data WHERE p_id=%d";  //patch_info_data WHERE p_id=%d";
							
							sprintf(sql, query, "p_id", "patch_filename",patch_list[file_i] );  //Check_num[file_i]); 0528
					//0723ġ ȭϿ شǴ ϵش p_id Էµ 

							printf("\n=== [4.0]:%s ===\n",sql);

							//DB  ϳ ̸  
							getdata(sql, Rx_msg, 4,0); //Ͽ DB Data  s_pid_file  
							//End DB
							write(clnt_sock, Rx_msg, BUFSIZE); //p_id, filename, f_size  (̸4.0) 5 25 

			//**----------------------------------------  ۺ ---------------------------------------------**//	
							int check_trans=0;

							//   Լ 
						    check_trans=file_transmit(clnt_sock, s_pid_file);

							if(check_trans == 0) { printf("  Ϸ(^^)\n");}
							else if (check_trans == 1) {printf("  ۿ  ..(--;;)");}

			//**----------------------------------------  ۺ  ------------------------------------------**//	



				}//file_i //0528

///////////////////////////

					//////
					//See_DB_SendFile()
					/////

					usleep(50000); //1/10000000

					printf("patch ؾ file  Ϸ !!\n");
					memset(Rx_msg, 0, BUFSIZE);

				}// 3.flag.1
			 	//Ŭ̾Ʈ  ۽Ŵ ޾Ҵ(ߴٰ) ȣ ޴°. 
				else if(r_hdr->flag == 2)
				{
					//Ŭ̾ƮԹ Ϸ patch ȣ  
					printf("\n Ŭ̾Ʈ patch file ſϷ \n");
					hdr_def(Rx_msg, 4,1);
					
					write(clnt_sock, Rx_msg, BUFSIZE);

				}// 3.flag.2
			}// command.3
			else if( r_hdr->command == 5)
 			 {
				 if( r_hdr->flag == 0)
				 {
					 r_backup_data = (struct backup_file_inform*)(Rx_msg + sizeof(struct hdr));
					 printf(" ------  flag[5.0] ------\n\n");
					 printf("filename = %s, date = %s \n path = %s, p_id = %d\n", r_backup_data->filename, r_backup_data->date, r_backup_data->path, r_backup_data->p_id);

					 ///////////////////////
					 /* DB   κ */
					 ///////////////////////

			 ///0723 ⼭  table ̸  Ƹ   μ   ִ.(upgrade..)
					 char *query="INSERT INTO Patch_Backup_info VALUES( %d, '%s', '%s', '%s', '%s')"; //κ %s(1) userID̴.

				//  .
					 sprintf(sql, query,r_backup_data->p_id, r_backup_data->filename, r_backup_data->date, r_backup_data->path, pipelist[Checkclnt].u_id); //κп ѱ UserID

					 printf("\n<<<< DB   [%d,%d]=%s >>>>\n", r_hdr->command, r_hdr->flag, sql);

					 //get ƴ϶  ϴ(5,0) storedata̴.
					 storedata(sql, 5, 0);
					 
				 } // 5.flag.0
				 
				 else if( r_hdr->flag == 1)
				 {
					 // Ȳ ˸ 
				     gcommand = 10;   //αλ 
				     gflag = 10;
				     ////////////////////////
					 printf(" ------   Ϸ ------ \n\n");
					 memset(Rx_msg, 0, BUFSIZE);
				 } // 5.flag.1
			 } // command.5

			 else if( r_hdr->command == 6)
			 {
				 if(r_hdr->flag == 0)
				 {
					 struct Recv_hdr *recov_hdr;
					 recov_hdr = (struct Recv_hdr*)Rx_msg; 
					 /////////////////////
					 //  Recovery û ް DB  
					 //  Client ش. 
					 ////////////////////
					 printf(" \n    >>(%d,%d,%d)<< \n",recov_hdr->command, recov_hdr->flag, recov_hdr->Rec_flag);
					 sleep(1);
					 memset(sql, 0, sizeof(sql));
					 char *query="SELECT p_id, p_filename, p_path from backup_info_data where user_id=%d AND p_id=%d";  // ̿ϼ 

					 sprintf(sql, query, clnt_uid, recov_hdr->Rec_flag); // sql̿ϼ 

					 printf(" \n=6.0= =%s \n",sql);

					 sleep(1);

					 //DB Ǿ ش Ŭ̾Ʈ ڷḦ  
					 getdata(sql, query, 6,0); 

					 write(clnt_sock, Rx_msg, BUFSIZE);
				 } // 6.flag.0
				 else if(r_hdr->flag == 2)
				 {
					 /// Clientκ REcovery  REport..
					 // Ȳ ˸ 
				      gcommand = 10;   //αλ
				      gflag = 10;
				     ////////////////////////
				 } // 6.flag.1
			 } // command.6

			//0804 Client  Check κ client  ȣ check
			else if( r_hdr->command == 10)
			{
				if(r_hdr->flag == 1)
				{
					int rewv1=0;

					chck_alive = (struct alive*)(Rx_msg + sizeof(struct hdr));

					printf("\n Ŭ̾Ʈκ  ִٴ %s \n\n",chck_alive->check);


					usleep(5000);

				}// 10.flag.1

			} // command.10

		   } //FD_ISSET=> Է ߻Ұ..

		}//ü retval>0

		//0819   ȵȴ. ..
		else //select 3° κ time expire  Ǵ κ 
		{

			 printf("\n select 3° κ \n");

			 hdr_def(Rx_msg, 10, 0); 
			 chck_alive = (struct alive*)(Rx_msg + sizeof(struct hdr));
			 
			 strcpy(chck_alive->check,"=from server ֳ?=");

			 printf(" \n %d retval=%d Timeout expire Ǿ Ŭ̾Ʈ Ȯ packet\n",timeout.tv_sec, retval);

		}// expire  

		    retval=0;

			memset(Rx_msg, 0, BUFSIZE); usleep(5000);
		}//End of while

		puts(" ");
		close(clnt_sock);
		exit(0);

        }//fd_set  
		   
		   //***********************************************//

	}//while(1)Forkõ
	
} //main End


void z_handler(int sig)
{
	pid_t pid;
	int rtn;
	char dead_clnt[2];

	
	pid = waitpid(-1, &rtn, WNOHANG);
	printf("Ҹ  μ ID: %d \n",pid);
	printf("ϵ (clnt_uid):[%d] \n",WEXITSTATUS(rtn) );
 /**--------------------------------------------------**/
	Checkclnt--; //׾ ϳ ٿش. 0926
 /**--------------------------------------------------**/

    //SMS..
 /*******----------------------------------------*******/
	int sms_sock;
	struct sockaddr_in sms_addr;
	char Smsg[BUFSIZE];

    sprintf(dead_clnt,"%d",WEXITSTATUS(rtn));

	printf("\n dead_clnt=%s \n", dead_clnt);

/*0926

	sms_sock = socket(PF_INET, SOCK_STREAM, 0);

	memset(&sms_addr, 0, sizeof(sms_addr));
	sms_addr.sin_family=AF_INET;
	sms_addr.sin_addr.s_addr=inet_addr("1xx.xxx.xxx.xxx");
	sms_addr.sin_port=htos(atoi("Ʈ"));

	if( connect(sms_sock, (struct sockaddr*)&sms_addr, sizeof(sms_addr)) == -1); // û.
	   error_handling("\n SMS server connect() error!! ");

	 
//	     strcpy(message, "GET /d/quotes.csv?s=");
//	     strcat(message,m_value);
//	     strcat(message,"&f=snl1d1t1c1ohgv&e=.csv\n");
    
	   memset(Smsg, 0 , BUFSIZE);
	   strcpy(Smsg,"   ");
	   strcat(Smsg,"   ");
	   strcat(Smsg,"   ");

	   printf("\n SMS   Smsg[%s] \n",Smsg);

	   Smsg[strlen(Smsg)]=0;

	   write( sms_sock, Smsg, strlen(Smsg)); //..
0926*/	
 /*******----------------------------------------*******/

}// z_handler

void error_handling(char *message)
{
	fputs(message, stderr);
	fputc('\n', stderr);
	exit(1);
}





 







	









